/***************************************************************************
 *   Name:      Music_Formater.h                                           *
 *   Purpose:   Tools to work with MusicFormat                             *
 *   Copyright (C) 2008 by Jackie Team                                     *
 *   jackie.team@gmail.com                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MUSIC_FORMATER_H
#define MUSIC_FORMATER_H
#include <taglib/fileref.h>
#include <wx/filename.h>
#include "Music_Format.h"
#include "components.h"
#ifdef USE_MP4
#include <taglib/mp4file.h>
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

/**
 * Class MusicFormater
 * This class allows to work simply with music files
 * in just giving it the file to deal with
 * (and the choicebook in order to retreive lists
 * that need updates)
 */

class MonChoicebook;
class MaListe;

class MusicFormater {
protected:
    wxString file;
    wxString extension;
    wxString name;
    wxString path;
    MonChoicebook* choiceBook;
public:
    /**
     * Constructor with the path of the file
     * to deal with
     */
    MusicFormater(wxString);
    /**
     * Constructor with the path of the file
     * to deal with, and the choicebook in order
     * to update lists
     */
    MusicFormater(wxString, MonChoicebook*);
    /**
     * The int is for files with multiples versions
     * of a tag (mp3)
     * MP3 : 0 : ID3v1
     *       1 : ID3v2
     */
    MusicFormat* getFormat(int);
    /**
     * Same as getFormat(int), but for files
     * which have an only version of a tag
     */
    MusicFormat* getFormat();
    /**
     * The int is for files with multiples versions
     * of a tags (mp3)
     * MP3 : 0 : ID3v1
     *       1 : ID3v2
     */
    MaListe* getList(int);
    /**
     * Same as getList(int), but for files
     * which have an only version of a tag
     */
    MaListe* getList();

    wxString getFileExtension();
    wxString getFileName();
    wxString getFilePath();
};
#endif
